// This is a closed-doors prototype.  Please don't distribute!  Thank you.  - Tricob
/*********************************************************************************************************************/
// Use "(Custom).H" for options;  it's easier to set up than VERSION.H was.
//
// Also, check FOREIGN.H for additional text

/*******************************************************************************************/
/* Don't mess with any of the lines below unless you know what you're doing.  Thanks!  :-) */
/*******************************************************************************************/

#ifndef CUSTOMFILEINCLUDED
#include "(Custom).h"
#include "__advanced.h"
#include "_signonsettings.h"
#define CUSTOMFILEINCLUDED
#endif

#ifndef _VERSION_H_
#define _VERSION_H_

#ifndef VERSIONALREADYCHOSEN              // used for batch compiling

/* Defines used for different versions */

//#define SPEAR
//#define SPEARDEMO
//#define UPLOAD
//#define GOODTIMES
//#define CARMACIZED
//#define APOGEE_1_0
//#define APOGEE_1_1
//#define APOGEE_1_2

#ifdef WOLF3D14APOGEE
#define CARMACIZED
#endif

#ifdef WOLF3D14GT
#define CARMACIZED
#define GOODTIMES
#endif

#ifdef WOLF3D14SHAREWARE
#define CARMACIZED
#define UPLOAD
#endif

#ifdef WOLF3D11WITH60LEV
#define CARMACIZED
#define APOGEE_1_1
#endif

#ifdef WOLF3D11WITH10LEV
#define CARMACIZED
#define APOGEE_1_1
#define UPLOAD
#endif

#ifdef WOLF3D10WITH10LEV
#define CARMACIZED
#define APOGEE_1_0
#define UPLOAD
#endif

#ifdef SPEAR21LEVELS
#define CARMACIZED
#define SPEAR
#endif

#ifdef SPEAR2LEVELS
#define CARMACIZED
#define SPEARDEMO
#define SPEAR
#endif

/*
    Wolf3d Full v1.1 Apogee (with ReadThis)   - define CARMACIZED and APOGEE_1_1
    Wolf3d Full v1.4 Apogee (with ReadThis)   - define CARMACIZED
    Wolf3d Full v1.4 GT/ID/Activision         - define CARMACIZED and GOODTIMES
    Wolf3d Shareware v1.0                     - define UPLOAD and APOGEE_1_0
    Wolf3d Shareware v1.1                     - define CARMACIZED and UPLOAD and APOGEE_1_1
    Wolf3d Shareware v1.2                     - define CARMACIZED and UPLOAD and APOGEE_1_2
    Wolf3d Shareware v1.4                     - define CARMACIZED and UPLOAD
    Spear of Destiny Full and Mission Disks   - define CARMACIZED and SPEAR
                                                (and GOODTIMES for no FormGen quiz)
    Spear of Destiny Demo                     - define CARMACIZED and SPEAR and SPEARDEMO
*/

#endif

#ifdef USE_FEATUREFLAGS
#define USE_SHADING         // Enables shading support (see wl_shade.cpp)
#define USE_PARALLAX 16     // Enables parallax sky with 16 textures per sky (see wl_parallax.cpp)
#define USE_CLOUDSKY        // Enables cloud sky support (see wl_cloudsky.cpp)
#define USE_STARSKY         // Enables star sky support (see wl_atmos.cpp)
#define USE_RAIN            // Enables rain support (see wl_atmos.cpp)
#define USE_SNOW            // Enables snow support (see wl_atmos.cpp)
#endif
//#define FIXRAINSNOWLEAKS    // Enables leaking ceilings fix (by Adam Biser, only needed if maps with rain/snow and ceilings exist)

#define LASTPATCHOBJ          (FIRSTPATCHOBJ+NUMPATCHES-1)

#ifdef SPEAR
#ifdef ENABLEREADTHIS
#ifndef DOTEXTFROMFILES
#define DOTEXTFROMFILES
#endif
#endif
#endif

#ifndef DOTEXTFROMFILES
#define ARTSEXTERN
#endif

#ifndef DODEMOSFROMFILES
#define DEMOSEXTERN
#endif

/*********************************************************************************************************************/
#define FIXADLIB              // Fix Adlib sound glitch when the treasure/food/ammo sound restarts

#define ENEMYNULLFIX          // Fix "PlayerDied" bug when killerobj = NULL

#define SHADINGBUGFIX         // Fix "shading bug" when quick-loading your saved game
#define SMARTLEVELCOUNT       // Don't hard-code levels with percentages;  count them individually, along with bosses
#define COMMONSENSEPAR        // If the par time is "??:??", assume the level is a boss level or a secret level

#ifndef SMARTLEVELCOUNT

#define LRPACKW3D             8     // # of levels to store in endgame for Wolf3D (without Seamless Levels)
#define LRPACKSOD             20    // # of levels to store in endgame for Spear or Seamless Levels

#define SODBOSS1LEV           5     // Boss 1 level for SOD
#define SODBOSS2LEV           10    // Boss 2 level for SOD
#define SODBOSS3LEV           16    // Boss 3 level for SOD
#define SODBOSS4LEV           18    // Boss 4 level for SOD
#define SODBOSS5LEV           0     // Boss 5 level for SOD
#define SODBOSS6LEV           0     // Boss 6 level for SOD
#define SODBOSS7LEV           0     // Boss 7 level for SOD
#define SODBOSS8LEV           0     // Boss 8 level for SOD
#define SODBOSS9LEV           0     // Boss 9 level for SOD

#else
#define LRPACKW3D             100   // # of levels to store in endgame for Wolf3D (without Seamless Levels)
#define LRPACKSOD             100   // # of levels to store in endgame for Spear or Seamless Levels
#endif

#ifndef USEGUARDBLOCKERS
#undef BLOCKGUARD1
#undef BLOCKGUARD2
#define BLOCKGUARD1           -1
#define BLOCKGUARD2           -2
#endif

#define SODTOSECRLV1          FIRSTSPEARSECRETLEVEL
#define SODTOSECRLV2          (SODTOSECRLV1+1)
#define SODTOSECRLV3          (SODTOSECRLV1+2)
#define SODTOSECRLV4          (SODTOSECRLV1+3)
#define SODTOSECRLV5          (SODTOSECRLV1+4)
#define SODTOSECRLV6          (SODTOSECRLV1+5)

#ifdef SPEAR
       #ifndef SEAMLESSLEVELS
               #define SEAMLESSLEVELS
       #endif
#endif


#ifdef WALLPATCH
#define LASTPATCHOBJ    (FIRSTPATCHOBJ+NUMPATCHES)
#endif

#ifdef INGAMEMESSAGES
#include "_messages.h"
#endif

#define TRICOBSMUSICFIX       // None of Ripper's "ContinueMusic" routine

#define PLANE1LOADSAVE        // Write Plane 1 (0/1/2) into save/load games

#define NEWPUSHWALLCODE

#define E6L10FIX              // Frozen boss in E6L10 fix

#define SPEARLEVEL4FIX        // Frozen SS in Spear Level 4 fix

#ifndef USEHUDACTORS
#undef DOHUDBLOODFEATURE
#endif

#ifndef USENEWSTATUSBAR

#undef SBAR_AMMO_X
#undef SBAR_AMMO_Y
#undef SBAR_FACE_X
#undef SBAR_FACE_Y
#undef SBAR_HEALTH_X
#undef SBAR_HEALTH_Y
#undef SBAR_KEY1_X
#undef SBAR_KEY1_Y
#undef SBAR_KEY2_X
#undef SBAR_KEY2_Y
#undef SBAR_KEY3_X
#undef SBAR_KEY3_Y
#undef SBAR_KEY4_X
#undef SBAR_KEY4_Y
#undef SBAR_LEVEL_X
#undef SBAR_LEVEL_Y
#undef SBAR_LIVES_X
#undef SBAR_LIVES_Y
#undef SBAR_SCORE_X
#undef SBAR_SCORE_Y
#undef SBAR_WEAPON_X
#undef SBAR_WEAPON_Y

#define SBAR_AMMO_X                  26   // Ammo - X Coordinate
#define SBAR_AMMO_Y                  16   // Ammo - Y Coordinate
#define SBAR_FACE_X                  17   // BJ's face drawn here - X Coordinate
#define SBAR_FACE_Y                  4    // BJ's face drawn here - Y Coordinate
#define SBAR_HEALTH_X                21   // Health - X Coordinate
#define SBAR_HEALTH_Y                16   // Health - Y Coordinate
#define SBAR_KEY1_X                  30   // Key #1 - X Coordinate
#define SBAR_KEY1_Y                  4    // Key #1 - Y Coordinate
#define SBAR_KEY2_X                  30   // Key #2 - X Coordinate
#define SBAR_KEY2_Y                  20   // Key #2 - Y Coordinate
#define SBAR_KEY3_X                  31   // Key #3 - X Coordinate
#define SBAR_KEY3_Y                  4    // Key #3 - Y Coordinate
#define SBAR_KEY4_X                  31   // Key #4 - X Coordinate
#define SBAR_KEY4_Y                  20   // Key #4 - Y Coordinate
#define SBAR_LEVEL_X                 2    // Current level - X Coordinate
#define SBAR_LEVEL_Y                 16   // Current level - Y Coordinate
#define SBAR_LIVES_X                 14   // Lives left - X Coordinate
#define SBAR_LIVES_Y                 16   // Lives left - Y Coordinate
#define SBAR_SCORE_X                 6    // Current score - X Coordinate
#define SBAR_SCORE_Y                 16   // Current score - Y Coordinate
#define SBAR_WEAPON_X                32   // Weapon currently in use - X Coordinate
#define SBAR_WEAPON_Y                8    // Weapon currently in use - Y Coordinate

#endif

#endif

#ifdef ENABLEREADTHIS
#ifdef GOODTIMES
#ifndef SPEAR
#ifndef UPLOAD

#undef GOODTIMES
#define USESMALLERGFXV

#endif
#endif
#endif
#endif
